;;; -*- mode: TI-Asm; ti-asm-listing-file: "units.lst" -*-
;;;
;;;	Unit Operations Flash App for TI-83+
;;; 
;;;	Copyright 2003 Benjamin Moody
;;;
;;;  This program is free software; you can redistribute
;;;  and/or modify it under the terms of the GNU General
;;;  Public License as published by the Free Software
;;;  Foundation; either version 2 of the License, or (at
;;;  your option) any later version.
;;;
;;;  This program is distributed in the hope that it will be
;;;  useful, but WITHOUT ANY WARRANTY; without even the
;;;  implied warranty of MERCHANTABILITY or FITNESS FOR A
;;;  PARTICULAR PURPOSE. See the GNU General Public License
;;;  for more details.
;;;
;;;  You should have received a copy of the GNU General
;;;  Public License along with this program; if not, write
;;;  to the Free Software Foundation, Inc., 59 Temple Place
;;;  - Suite 330, Boston, MA 02111 USA.
;;;

;;; menu.asm: menu data

UnitMenuHeaders:
	.dw MenuUnit
UNITStr:
	.db "UNIT",0
	.dw MenuPrefix
	.db "PREFIX",0
	.dw MenuConst
	.db "CONS",0

UnitMenuHeadersPrefixed:
	.dw MenuUnit
	.db "UNIT",0
	.dw MenuConst
	.db "CONST",0
	.dw MenuUnit
	.db 0
	
MenuPrefix:
	.db 20
	.dw yotta
	.dw zetta
	.dw exa
	.dw peta
	.dw tera
	.dw giga
	.dw mega
	.dw kilo
	.dw hecto
	.dw deka
	.dw deci
	.dw centi
	.dw milli
	.dw micro
	.dw nano
	.dw pico
	.dw femto
	.dw atto
	.dw zepto
	.dw yocto

UnitMenuSubs:
	.dw MenuUnit,UNITStr
	.dw MenuPreset,PresetsStr	; 1
	.dw MenuLength,LengthUnitsStr	; 2
	.dw MenuArea,AreaUnitsStr	; 3
	.dw MenuVol,VolUnitsStr		; 4
	.dw MenuMass,MassUnitsStr	; 5
	.dw MenuTime,TimeUnitsStr	; 6
	.dw MenuTemp,TempUnitsStr	; 7
	.dw MenuVelo,VeloUnitsStr	; 8
	.dw MenuForce,ForceUnitsStr	; 9
	.dw MenuPres,PresUnitsStr	; 10
	.dw MenuEner,EnerUnitsStr	; 11
	.dw MenuPower,PowerUnitsStr	; 12
	.dw MenuElec,ElecUnitsStr	; 13
	.dw MenuPhot,PhotUnitsStr	; 14
	.dw MenuRad,RadUnitsStr		; 15
	.dw MenuFlow,FlowUnitsStr	; 16
	.dw MenuOther,OtherUnitsStr	; 17

	.dw MenuFund,FundConstsStr	; 18
	.dw MenuChem,ChemConstsStr	; 19
	.dw MenuPhys,PhysConstsStr	; 20
	.dw MenuPart,PartConstsStr	; 21
SUB_ALPH = 22
	.dw MenuAllUnit,AllUnitsStr	; 22
	.dw MenuAllConst,AllConstStr	; 23

PresetsStr:
	.db "Presets",0
AllUnitsStr:
	.db "All Units",0
AllConstStr:
	.db "All Constants",0
LengthUnitsStr:
	.db "Length",0
MassUnitsStr:
	.db "Mass",0
TimeUnitsStr:
	.db "Time",0
TempUnitsStr:
	.db "Temperature",0
AreaUnitsStr:
	.db "Area",0
VolUnitsStr:
	.db "Volume",0
VeloUnitsStr:
	.db "Velocity",0
ForceUnitsStr:
	.db "Force",0
PresUnitsStr:
	.db "Pressure",0
EnerUnitsStr:
	.db "Work/Energy",0
PowerUnitsStr:
	.db "Power",0
ElecUnitsStr:
	.db "Electric",0
PhotUnitsStr:
	.db "Photometric",0
RadUnitsStr:
	.db "Radiation",0
FlowUnitsStr:
	.db "Flow",0
OtherUnitsStr:
	.db "Miscellaneous",0
FundConstsStr:
	.db "Fundamental",0
ChemConstsStr:
	.db "Chemical",0
PhysConstsStr:
	.db "Physical",0
PartConstsStr:
	 .db "Particle Prop",0


MenuUnit:
	.db 18
	.dw 22
	.dw 1
	.dw 2
	.dw 3
	.dw 4
	.dw 5
	.dw 6
	.dw 7
	.dw 8
	.dw 9
	.dw 10
	.dw 11
	.dw 12
	.dw 13
	.dw 14
	.dw 15
	.dw 16
	.dw 17

MenuPreset:
	.db 3
	.dw convde
	.dw convab
	.dw convam

MenuLength:
	.db 17
	.dw angstr
	.dw mil
	.dw line
	.dw inch
	.dw foot

	.dw yard
	.dw meter
	.dw fathom
	.dw rod
	.dw chain

	.dw flng
	.dw mile
	.dw nmile
	.dw ltsec
	.dw au

	.dw ltyr
	.dw parsec

MenuArea:
	.db 2
	.dw acre
	.dw are

MenuVol:
	.db 14
	.dw liter
	.dw cc
	.dw gallon
	.dw quart
	.dw cup

	.dw pint
	.dw floz
	.dw barrel
	.dw bushel
	.dw peck

	.dw tbsp
	.dw tsp
	.dw ccf
	.dw Mcf

MenuMass:
	.db 9
	.dw amu
	.dw gram
	.dw dram
	.dw ounce
	.dw carat
	.dw pound
	.dw slug
	.dw ton
	.dw tonne

MenuTime:
	.db 8
	.dw second
	.dw minute
	.dw hour
	.dw day
	.dw week
	.dw month
	.dw year
	.dw hertz

MenuTemp:
	.db 4
	.dw kelvin
	.dw degR
	.dw __ZdegF
	.dw __ZdegC

MenuVelo:
	.db 6
	.dw knot
	.dw mph
	.dw kph
	.dw fpm
	.dw fps
	.dw ipy

MenuForce:
	.db 5
	.dw newton
	.dw lbf
	.dw dyne
	.dw gf
	.dw pond

MenuPres:
	.db 12
	.dw pascal
	.dw atm
	.dw bar
	.dw vac
	.dw psi
	.dw torr
	.dw mercur
	.dw water
	.dw mhg
	.dw mh2o
	.dw inhg
	.dw inh2o

MenuEner:
	.db 11
	.dw joule
	.dw calor
	.dw Calor
	.dw eV
	.dw erg
	.dw btu
	.dw chu
	.dw toe
	.dw tnt
	.dw Wh
	.dw hph

MenuPower:
	.db 3
	.dw watt
	.dw horse
	.dw mbh
	
MenuElec:
	.db 10
	.dw ampere
	.dw watt
	.dw coulom
	.dw volt
	.dw ohm
	.dw siemen
	.dw farad
	.dw weber
	.dw henry
	.dw tesla


MenuPhot:
	.db 10
	.dw candel
	.dw lumen
	.dw lux
	.dw phot
	.dw mcs
	.dw lam
	.dw nit
	.dw sb
	.dw asb
	.dw fl

MenuRad:
	.db 7
	.dw Bq
	.dw Ci
	.dw Gy
	.dw rad
	.dw rep
	.dw Sv
	.dw rem

MenuFlow:
	.db 14
	.dw gph
	.dw gpm
	.dw mgd
	.dw cfh
	.dw cfm
	.dw cfs
	.dw lpm
	.dw lfm
	.dw sccm
	.dw sccs
	.dw scfh
	.dw slph
	.dw slpm
	.dw lusec

MenuOther:
	.db 11
	.dw gal
	.dw gsm
	.dw poise
	.dw stokes
	.dw mpg
	.dw mole	
	.dw ppm
	.dw ppb
	.dw ppt
	.dw proof
	.dw karat


MenuAllUnit:
	.db 142

	.dw __ZdegC
	.dw __ZdegF
	.dw ampere
	.dw angstr
	.dw acre
	.dw are
	.dw asb
	.dw atm
	.dw au
	.dw bar
	.dw barrel
	.dw Bq
	.dw btu
	.dw bushel
	.dw coulom
	.dw Calor
	.dw calor
	.dw cc
	.dw ccf
	.dw candel
	.dw cfh
	.dw cfm
	.dw cfs
	.dw chain
	.dw chu
	.dw Ci
	.dw carat
	.dw cup
	.dw day
	.dw dram
	.dw dyne
	.dw erg
	.dw eV
	.dw farad
	.dw fathom
	.dw fl
	.dw flng
	.dw floz
	.dw fpm
	.dw fps
	.dw foot
	.dw gram
	.dw gal
	.dw gallon
	.dw gf
	.dw gph
	.dw gpm
	.dw gsm
	.dw Gy
	.dw water
	.dw mercur
	.dw henry
	.dw hour
	.dw horse
	.dw hph
	.dw hertz
	.dw inch
	.dw inh2o
	.dw inhg
	.dw ipy
	.dw joule
	.dw kelvin
	.dw knot
	.dw kph
	.dw karat
	.dw liter
	.dw lam
	.dw pound
	.dw lbf
	.dw lfm
	.dw line
	.dw lpm
	.dw lumen
	.dw ltsec
	.dw lusec
	.dw lux
	.dw ltyr
	.dw meter
	.dw mbh
	.dw Mcf
	.dw mcs
	.dw mgd
	.dw mh2o
	.dw mhg
	.dw mile
	.dw mil
	.dw minute
	.dw month
	.dw mole
	.dw mpg
	.dw mph
	.dw nit
	.dw nmile
	.dw ohm
	.dw ounce
	.dw poise
	.dw pond
	.dw pascal
	.dw parsec
	.dw phot
	.dw peck
	.dw ppb
	.dw ppm
	.dw ppt
	.dw proof
	.dw psi
	.dw pint
	.dw quart
	.dw degR
	.dw rad
	.dw rod
	.dw rem
	.dw rep
	.dw siemen
	.dw second
	.dw sb
	.dw sccm
	.dw sccs
	.dw scfh
	.dw scfm
	.dw slph
	.dw slpm
	.dw slug
	.dw stokes
	.dw Sv
	.dw tesla
	.dw tonne
	.dw tbsp
	.dw tnt
	.dw toe
	.dw ton
	.dw torr
	.dw tsp
	.dw amu
	.dw volt
	.dw vac
	.dw watt
	.dw weber
	.dw Wh
	.dw week
	.dw yard
	.dw year

MenuConst:
	.db 7
	.dw 23
	.dw 18
	.dw 19
	.dw 20
	.dw 21
	.dw __pi
	.dw ver

MenuFund:
	.db 7
	.dw __G
	.dw __c
	.dw __mu0
	.dw __eps0
	.dw __h
	.dw __hbar
	.dw __kC

MenuChem:
	.db 8
	.dw __N_A
	.dw __R
	.dw __k
	.dw __Rinf
	.dw __R_H
	.dw __alph
	.dw __ZdegF
	.dw __ZdegC

MenuPhys
	.db 5
	.dw __e
	.dw __g
	.dw __m_P
	.dw __t_P
	.dw __l_P

MenuPart:
	.db 16
	.dw __me
	.dw __mp
	.dw __mn
	.dw __mmu
	.dw __mal

	.dw __mde
	.dw __mu_B
	.dw __mu_N
	.dw __mumu
	.dw __mu_p

	.dw __mu_e
	.dw __mu_n
	.dw __mu_d
	.dw __l_C
	.dw __l_Cp

	.dw __l_Cn

MenuAllConst:
	.db 37

	.dw __ZdegC
	.dw __ZdegF
	.dw __alph
	.dw __c
	.dw __e

	.dw __eps0
	.dw __G
	.dw __g
	.dw __h
	.dw __hbar

	.dw __k
	.dw __kC
	.dw __l_P
	.dw __l_C
	.dw __l_Cn

	.dw __l_Cp
	.dw __m_P
	.dw __mal
	.dw __mde
	.dw __me

	.dw __mmu
	.dw __mn
	.dw __mp
	.dw __mu0
	.dw __mu_B

	.dw __mu_d
	.dw __mu_e
	.dw __mumu
	.dw __mu_N
	.dw __mu_n

	.dw __mu_p
	.dw __N_A
	.dw __pi
	.dw __R
	.dw __R_H

	.dw __Rinf
	.dw __t_P


MenuCharTable:
	.db "1234567890ABCDEFGH"
	.db "IJKLMNOPQRSTUVWXYZ"

; TokToKeyTable:
; 	;; These tables actually overlap too much, so they would need
; 	;; to be separated in order to add multi-character tokens.
; 	.db 0,0,0,0,0,0,0,0
; 	.db kStore,0,0,0,kLBrack,0,kRBrack,0
; 	.db kLBrace,0,kRBrace,0,$FE,kRad,$FE,kDegr
; 	.db kInv,0,kSquare,0,$FE,kTransp,$FE,kCube

; 	.db kLParen,0,kRParen,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0

; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,kSpace,0,kQuote,0,kComma,0
; 	.db kI,0,$FE,kXFactorial,0,0,0,0

; 	.db k0,0,k1,0,k2,0,k3,0
; 	.db k4,0,k5,0,k6,0,k7,0
; 	.db k8,0,k9,0,kDecPnt,0,kEE,0
; 	.db 0,0,0,0,kColon,0,kEnter,0

; 	.db 0,0,kCapA,0,kCapB,0,kCapC,0
; 	.db kCapD,0,kCapE,0,kCapF,0,kCapG,0
; 	.db kCapH,0,kCapI,0,kCapJ,0,kCapK,0
; 	.db kCapL,0,kCapM,0,kCapN,0,kCapO,0

; 	.db kCapP,0,kCapQ,0,kCapR,0,kCapS,0
; 	.db kCapT,0,kCapU,0,kCapV,0,kCapW,0
; 	.db kCapX,0,kCapY,0,kCapZ,0,kTheta,0
; 	.db 0,0,0,0,0,0,0,0

; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,$FE,kTEqu,$FE,kTLT
; 	.db $FE,kTGT,$FE,kTLTE,$FE,kTGTE,$FE,kTNoteQ

; 	.db kAdd,0,kSub,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0

; 	.db 0,0,0,0,kMul,0,kDiv,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0

; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0

; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db kPi,0,0,0,kAPost,0,kQuest,0

; 	.db kChs,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0

; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0

; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0

; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0

; 	.db kExpon

; TokToKeyTable2:
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0

; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0

; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0

; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0

; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0

; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0

; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,$FC,kcapAAcute,$FC,kcapAGrave

; 	.db $FC,kcapACaret,$FC,kcapADier,$FC,kaAcute,$FC,kaGrave
; 	.db $FC,kaCaret,$FC,kaDier,$FC,kcapEAcute,$FC,kcapEGrave
; 	.db $FC,kcapECaret,$FC,kcapEDier,$FC,keAcute,$FC,keGrave
; 	.db $FC,keCaret,$FC,keDier,0,0,           $FC,kcapIGrave

; 	.db $FC,kcapICaret,$FC,kcapIDier,$FC,kiAcute,$FC,kiGrave
; 	.db $FC,kiCaret,$FC,kiDier,$FC,kcapOAcute,$FC,kcapOGrave
; 	.db $FC,kcapOCaret,$FC,kcapODier,$FC,koAcute,$FC,koGrave
; 	.db $FC,koCaret,$FC,koDier,$FC,kcapUAcute,$FC,kcapUGrave

; 	.db $FC,kcapUCaret,$FC,kcapUDier,$FC,kuAcute,$FC,kuGrave
; 	.db $FC,kuCaret,$FC,kuDier,$FC,kcapCCed,$FC,kcCed
; 	.db $FC,kcapNTilde,$FC,knTilde,$FC,kaccent,$FC,kgrave
; 	.db $FC,kdieresis,$FC,kquesDown,$FC,kexclamDown,$FC,kalpha

; 	.db $FC,kbeta,$FC,kgamma,$FC,kcapDelta,$FC,kdelta
; 	.db $FC,kepsilon,$FC,klambda,$FC,kmu,$FC,kpi2
; 	.db $FC,krho,$FC,kcapSigma,0,0,$FC,kphi
; 	.db $FC,kcapOmega,$FC,kphat,$FC,kchi2,$FC,kstatF2

; 	.db $FC,kLa,$FC,kLb,$FC,kLc,$FC,kLd
; 	.db $FC,kLe,$FC,kLf,$FC,kLg,$FC,kLh
; 	.db $FC,kLi,$FC,kLj,$FC,kLk,0,0
; 	.db $FC,kLl,$FC,kLm,$FC,kLsmalln,$FC,kLo

; 	.db $FC,kLp,$FC,kLq,$FC,kLsmallr,$FC,kLs
; 	.db $FC,kLt,$FC,kLu,$FC,kLv,$FC,kLw
; 	.db $FC,kLx,$FC,kLy,$FC,kLz,$FC,ksigma
; 	.db $FC,tLtau,$FC,kcapIAcute,0,0,$FB,kTilde

; 	.db $FB,kReserved,$FB,kAtSign,$FB,kPound,$FB,kDollar
; 	.db $FB,kAmpersand,$FB,kBackQuote,$FB,kSemicolon,$FB,kBackSlash
; 	.db $FB,kVertSlash,$FB,kUnderscore,$FB,kPercent,0,0
; 	.db 0,0,0,0,0,0,0,0

; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0

; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0
; 	.db 0,0,0,0,0,0,0,0

;;; Just for amusement: this is what the original rawkeyhook data
;;; looked like.  I think this is all the rawkeyhook could do when I
;;; submitted it to TI.

; CharMenuStr:
; 	.db "CHARACTER",$D6,0
; 	.db "1:",Lalpha,$D6
; 	.db "2:",LcapACaret," (angstrom)",$D6
; 	.db "3:",Lepsilon,$D6
; 	.db "4:",Lmu,$D6
; 	.db "5:",LcapOmega,$D6
; 	.db 0

; CharMenuTable:
; 	.db kalpha, kExtendEcho2
; 	.db kcapACaret, kExtendEcho2
; 	.db kepsilon, kExtendEcho2
; 	.db kmu, kExtendEcho2
; 	.db kcapOmega, kExtendEcho2


.org ($+$ff)&($ff00)

Alphabet2_H = ($>>8)&$ff

	.db 0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0

	.db 0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0

	.db 0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0

	.db 0,15,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0


	.db 0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0

	.db 0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0

	.db 0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,11,11

	.db 11,11,11,11,11,11,15,15
	.db 15,15,15,15,15,15,0,19


	.db 19,19,19,19,19,19,25,25
	.db 25,25,25,25,25,25,31,31

	.db 31,31,31,31,31,31,13,13
	.db 24,24,0,0,0,0,0,11

	.db 12,17,14,14,15,22,23,26
	.db 28,29,0,16,25,26,13,16

	.db 11,12,13,14,15,16,17,18
	.db 19,20,21,0,22,23,24,25


	.db 26,27,28,29,30,31,32,33
	.db 34,35,36,29,30,19,0,0

	.db 0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0

	.db 10,1,2,3,4,5,6,7
	.db 8,9,0,0,0,0,0,0

	.db 0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0

